#ifndef _USEC_H_
#define _USEC_H_

#ifdef __cplusplus
extern "C" {
#endif



#define USEC_CB_LOG		0
#define USEC_CB_AUDIT	1
#define USEC_CB_VALIDATE	2
#define USEC_CB_SETENFORCE	3
#define USEC_CB_POLICYLOAD	4

/* Function about usec */
extern int is_usec_enabled_raw(void);
extern int is_usec_enabled(void);
void set_usecmnt(const char *mnt);
int usecfs_exists(void);
void fini_usecmnt(void);

extern int usec_getenforcemode(int *enforce);

	/* Logging type codes, passed to the logging callback */
#define USEC_ERROR	        0
#define USEC_WARNING		1
#define USEC_INFO		2
#define USEC_UAVC		3
#define USEC_TRANS_DIR	"/var/run/setrans"


/* Definitions of av_decision.flags */
#define USEC_AVD_FLAGS_PERMISSIVE	0x0001

/**
 * usec_check_access - Check permissions and perform appropriate auditing.
 * @scon: source security context
 * @tcon: target security context
 * @tclass: target security class string
 * @perm: requested permissions string, interpreted based on @tclass
 * @auditdata: auxiliary audit data
 *
 * Check the AVC to determine whether the @perm permissions are granted
 * for the SID pair (@scon, @tcon), interpreting the permissions
 * based on @tclass.
 * Return %0 if all @perm permissions are granted, -%1 with 
 * @errno set to %EACCES if any permissions are denied or to another 
 * value upon other errors.
 * If auditing or logging is configured the appropriate callbacks will be called
 * and passed the auditdata field
 */
extern int usec_check_access(const char * scon, const char * tcon, const char *tclass, const char *perm, void *auditdata);


#ifdef __cplusplus
}
#endif
#endif
